#!/bin/bash
file="/tmp/newsnap_info"
docker exec miner miner snapshot info /var/data/snap/$1 > $file
height=$(cat $file | grep Height | awk '{print $2}')
hashline=$(cat $file | grep Hash -n | grep Hash | awk -F: '{print $1}')
hashline1=`expr $hashline + 1`
tmp1=$(cat $file | head -$hashline | tail -1 | awk '{print $2}')
tmp2=$(cat $file | head -$hashline1 | tail -1 | awk '{print $1}')
hash=$(echo $tmp1$tmp2)
hash1=$(cat $file | head -$hashline1 | tail -1 | awk '{print $2}' | awk -F\" '{print $2}')

echo $hash
echo $hash1

hash=$(echo $hash | awk -F'<<' '{print $2}' | awk -F'>>' '{print $1}')
error=0;

hashlength=${#hash1}
if [ "$hashlength" != "64" ]
then
	echo hash error
	exit 0
fi

for((i=1;i<=32;i++))
do
	tmp=$(echo $hash | awk -v i="$i" -F, '{print $i}')
	n=`expr 2 \* $i - 2`
	tmp1=${hash1:`expr 2 \* $i - 2`:2}
	tmp1=$((16#$tmp1))
	if [ "$tmp" != "$tmp1" ]
	then
		error=`expr $error + 1`
	fi
done

if [ "$error" != "0" ]
then
	echo hash error
       exit
fi
killall get_miner_conf.sh
miner_conf_path="/root/miner_config/docker.config"
cat /root/miner_config/docker_conf.start > $miner_conf_path
echo "      {blessed_snapshot_block_height, $height}," >> $miner_conf_path
echo "      {blessed_snapshot_block_hash, <<$hash>>}," >> $miner_conf_path
echo "      {fetch_latest_from_snap_source, false}," >> $miner_conf_path
cat /root/miner_config/docker_conf.end >> $miner_conf_path

sync
mv /root/miner_data/snap/$1 /root/miner_data/snap/snap-$height
sync
docker stop miner
cd  /root/miner_data/
rm -rf `ls | grep -v "snap"`
rm -rf saved-snaps
cd /root/miner_data/snap
rm -rf `ls | grep -v snap-"$height"`
docker start miner
rm -rf /root/snap-*
sync
